_Uart1_interrupt:
;UartTests.c,39 :: 		void Uart1_interrupt() iv IVT_INT_USART1 ics ICS_AUTO {
;UartTests.c,40 :: 		GPIOE_ODR.B8 = 1 ;            // for debug & timing
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOE_ODR+0)
MOVT	R0, #hi_addr(GPIOE_ODR+0)
STR	R1, [R0, #0]
;UartTests.c,42 :: 		if(RXNEIE_USART1_CR1_bit == 1) {    // are Rx data ready ints enabled ?
MOVW	R1, #lo_addr(RXNEIE_USART1_CR1_bit+0)
MOVT	R1, #hi_addr(RXNEIE_USART1_CR1_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_Uart1_interrupt0
;UartTests.c,43 :: 		if(RXNE_USART1_SR_bit == 1) {      // yes, is interupt pending ?
MOVW	R1, #lo_addr(RXNE_USART1_SR_bit+0)
MOVT	R1, #hi_addr(RXNE_USART1_SR_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_Uart1_interrupt1
;UartTests.c,44 :: 		RXNE_USART1_SR_bit = 0 ;          // yes, reset int flag
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(RXNE_USART1_SR_bit+0)
MOVT	R0, #hi_addr(RXNE_USART1_SR_bit+0)
STR	R1, [R0, #0]
;UartTests.c,45 :: 		RxChr = USART1_DR ;               // save rx chr
MOVW	R0, #lo_addr(USART1_DR+0)
MOVT	R0, #hi_addr(USART1_DR+0)
LDR	R1, [R0, #0]
MOVW	R0, #lo_addr(_RxChr+0)
MOVT	R0, #hi_addr(_RxChr+0)
STRB	R1, [R0, #0]
;UartTests.c,46 :: 		if(RxCnt < RXD_BUFF) {            // any room in rx buffer ?
MOVW	R0, #lo_addr(_RxCnt+0)
MOVT	R0, #hi_addr(_RxCnt+0)
LDRH	R0, [R0, #0]
CMP	R0, #20
IT	CS
BCS	L_Uart1_interrupt2
;UartTests.c,47 :: 		RxData[RxWp] = RxChr ;           // yes,put copy in buffer
MOVW	R2, #lo_addr(_RxWp+0)
MOVT	R2, #hi_addr(_RxWp+0)
LDRH	R1, [R2, #0]
MOVW	R0, #lo_addr(_RxData+0)
MOVT	R0, #hi_addr(_RxData+0)
ADDS	R1, R0, R1
MOVW	R0, #lo_addr(_RxChr+0)
MOVT	R0, #hi_addr(_RxChr+0)
LDRB	R0, [R0, #0]
STRB	R0, [R1, #0]
;UartTests.c,48 :: 		RxWp++ ;                         // inc pntr
MOV	R0, R2
LDRH	R0, [R0, #0]
ADDS	R0, R0, #1
UXTH	R0, R0
STRH	R0, [R2, #0]
;UartTests.c,49 :: 		if(RxWp >= RXD_BUFF)             // past end of buffer ?
CMP	R0, #20
IT	CC
BCC	L_Uart1_interrupt3
;UartTests.c,50 :: 		RxWp = 0 ;                      // yes, wrap to start
MOVS	R1, #0
MOVW	R0, #lo_addr(_RxWp+0)
MOVT	R0, #hi_addr(_RxWp+0)
STRH	R1, [R0, #0]
L_Uart1_interrupt3:
;UartTests.c,51 :: 		RxCnt++ ;                        // inc data cnt
MOVW	R1, #lo_addr(_RxCnt+0)
MOVT	R1, #hi_addr(_RxCnt+0)
LDRH	R0, [R1, #0]
ADDS	R0, R0, #1
STRH	R0, [R1, #0]
;UartTests.c,52 :: 		}
L_Uart1_interrupt2:
;UartTests.c,53 :: 		}
L_Uart1_interrupt1:
;UartTests.c,54 :: 		}
L_Uart1_interrupt0:
;UartTests.c,56 :: 		if(TXEIE_USART1_CR1_bit == 1) {     // are TX buffer empty ints enabled ?
MOVW	R1, #lo_addr(TXEIE_USART1_CR1_bit+0)
MOVT	R1, #hi_addr(TXEIE_USART1_CR1_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_Uart1_interrupt4
;UartTests.c,57 :: 		if(TXE_USART1_SR_bit == 1) {       // yes, is interupt pending ?
MOVW	R1, #lo_addr(TXE_USART1_SR_bit+0)
MOVT	R1, #hi_addr(TXE_USART1_SR_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_Uart1_interrupt5
;UartTests.c,58 :: 		TXE_USART1_SR_bit = 0 ;           // yes, reset int flag
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(TXE_USART1_SR_bit+0)
MOVT	R0, #hi_addr(TXE_USART1_SR_bit+0)
STR	R1, [R0, #0]
;UartTests.c,59 :: 		if(TxCnt > 0) {                   // any data waiting ?
MOVW	R0, #lo_addr(_TxCnt+0)
MOVT	R0, #hi_addr(_TxCnt+0)
LDRH	R0, [R0, #0]
CMP	R0, #0
IT	LS
BLS	L_Uart1_interrupt6
;UartTests.c,60 :: 		USART1_DR = TxData[TxRp] ;       // yes, tx next data
MOVW	R2, #lo_addr(_TxRp+0)
MOVT	R2, #hi_addr(_TxRp+0)
LDRH	R1, [R2, #0]
MOVW	R0, #lo_addr(_TxData+0)
MOVT	R0, #hi_addr(_TxData+0)
ADDS	R0, R0, R1
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(USART1_DR+0)
MOVT	R0, #hi_addr(USART1_DR+0)
STR	R1, [R0, #0]
;UartTests.c,61 :: 		TxRp++ ;                         // inc rd pntr
MOV	R0, R2
LDRH	R0, [R0, #0]
ADDS	R0, R0, #1
UXTH	R0, R0
STRH	R0, [R2, #0]
;UartTests.c,62 :: 		if(TxRp >= TXD_BUFF)             // past end of buffer ?
CMP	R0, #20
IT	CC
BCC	L_Uart1_interrupt7
;UartTests.c,63 :: 		TxRp = 0 ;                      // yes, wrap to start
MOVS	R1, #0
MOVW	R0, #lo_addr(_TxRp+0)
MOVT	R0, #hi_addr(_TxRp+0)
STRH	R1, [R0, #0]
L_Uart1_interrupt7:
;UartTests.c,64 :: 		TxCnt-- ;                        // dec data cnt
MOVW	R1, #lo_addr(_TxCnt+0)
MOVT	R1, #hi_addr(_TxCnt+0)
LDRH	R0, [R1, #0]
SUBS	R0, R0, #1
UXTH	R0, R0
STRH	R0, [R1, #0]
;UartTests.c,65 :: 		if(TxCnt == 0)                   // last data in buffer ?
CMP	R0, #0
IT	NE
BNE	L_Uart1_interrupt8
;UartTests.c,66 :: 		TXEIE_USART1_CR1_bit = 0 ;      // yes, disable uart TX interupts
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(TXEIE_USART1_CR1_bit+0)
MOVT	R0, #hi_addr(TXEIE_USART1_CR1_bit+0)
STR	R1, [R0, #0]
L_Uart1_interrupt8:
;UartTests.c,67 :: 		}
L_Uart1_interrupt6:
;UartTests.c,68 :: 		}
L_Uart1_interrupt5:
;UartTests.c,69 :: 		}
L_Uart1_interrupt4:
;UartTests.c,71 :: 		GPIOE_ODR = 0;                 // for debug & timing
MOVS	R1, #0
MOVW	R0, #lo_addr(GPIOE_ODR+0)
MOVT	R0, #hi_addr(GPIOE_ODR+0)
STR	R1, [R0, #0]
;UartTests.c,72 :: 		}
L_end_Uart1_interrupt:
BX	LR
; end of _Uart1_interrupt
_main:
;UartTests.c,77 :: 		void main() {
;UartTests.c,79 :: 		GPIO_Digital_Output(&GPIOE_BASE, _GPIO_PINMASK_ALL);  // Enable digital output on PORTE for debugging
MOVW	R1, #65535
MOVW	R0, #lo_addr(GPIOE_BASE+0)
MOVT	R0, #hi_addr(GPIOE_BASE+0)
BL	_GPIO_Digital_Output+0
;UartTests.c,80 :: 		GPIOE_ODR = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(GPIOE_ODR+0)
MOVT	R0, #hi_addr(GPIOE_ODR+0)
STR	R1, [R0, #0]
;UartTests.c,82 :: 		GPIO_Alternate_Function_Enable(&_GPIO_MODULE_USART1_PA9_10) ;  // Enable UART1 on GPIO_PORTA
MOVW	R0, #lo_addr(__GPIO_MODULE_USART1_PA9_10+0)
MOVT	R0, #hi_addr(__GPIO_MODULE_USART1_PA9_10+0)
BL	_GPIO_Alternate_Function_Enable+0
;UartTests.c,84 :: 		RxWp = RxRp = RxCnt = 0 ;         // init buffer pointers
MOVS	R1, #0
MOVW	R0, #lo_addr(_RxCnt+0)
MOVT	R0, #hi_addr(_RxCnt+0)
STRH	R1, [R0, #0]
MOVW	R1, #0
MOVW	R0, #lo_addr(_RxRp+0)
MOVT	R0, #hi_addr(_RxRp+0)
STRH	R1, [R0, #0]
MOVW	R1, #0
MOVW	R0, #lo_addr(_RxWp+0)
MOVT	R0, #hi_addr(_RxWp+0)
STRH	R1, [R0, #0]
;UartTests.c,85 :: 		TxWp = TxRp = TxCnt = 0 ;
MOVS	R1, #0
MOVW	R0, #lo_addr(_TxCnt+0)
MOVT	R0, #hi_addr(_TxCnt+0)
STRH	R1, [R0, #0]
MOVW	R1, #0
MOVW	R0, #lo_addr(_TxRp+0)
MOVT	R0, #hi_addr(_TxRp+0)
STRH	R1, [R0, #0]
MOVW	R1, #0
MOVW	R0, #lo_addr(_TxWp+0)
MOVT	R0, #hi_addr(_TxWp+0)
STRH	R1, [R0, #0]
;UartTests.c,87 :: 		RCC_APB2ENR.USART1EN = 1 ;        // Turn on USART1 module clocks
MOVS	R2, #1
SXTB	R2, R2
MOVW	R0, #lo_addr(RCC_APB2ENR+0)
MOVT	R0, #hi_addr(RCC_APB2ENR+0)
STR	R2, [R0, #0]
;UartTests.c,88 :: 		USART1_CR1.UE = 1 ;               // Enable USART1
MOVW	R0, #lo_addr(USART1_CR1+0)
MOVT	R0, #hi_addr(USART1_CR1+0)
STR	R2, [R0, #0]
;UartTests.c,89 :: 		USART1_CR1.M = 0 ;                // set 8 bit data len  (reset default, can be ignored)
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(USART1_CR1+0)
MOVT	R0, #hi_addr(USART1_CR1+0)
STR	R1, [R0, #0]
;UartTests.c,90 :: 		USART1_CR1.PCE = 0 ;              // set no parity       (reset default, can be ignored)
MOVW	R0, #lo_addr(USART1_CR1+0)
MOVT	R0, #hi_addr(USART1_CR1+0)
STR	R1, [R0, #0]
;UartTests.c,91 :: 		USART1_CR2.STOP0 = 0 ;            // set 1 stop bit      (reset default, can be ignored)
MOVW	R0, #lo_addr(USART1_CR2+0)
MOVT	R0, #hi_addr(USART1_CR2+0)
STR	R1, [R0, #0]
;UartTests.c,92 :: 		USART1_CR2.STOP1 = 0 ;            //    ditto            (reset default, can be ignored)
MOVW	R0, #lo_addr(USART1_CR2+0)
MOVT	R0, #hi_addr(USART1_CR2+0)
STR	R1, [R0, #0]
;UartTests.c,93 :: 		USART1_BRR = 7500 ;               // set baud rate 9600 (osc freq / baudrate)
MOVW	R1, #7500
MOVW	R0, #lo_addr(USART1_BRR+0)
MOVT	R0, #hi_addr(USART1_BRR+0)
STR	R1, [R0, #0]
;UartTests.c,94 :: 		USART1_CR1.RE = 1 ;               // enable rx
MOVW	R0, #lo_addr(USART1_CR1+0)
MOVT	R0, #hi_addr(USART1_CR1+0)
STR	R2, [R0, #0]
;UartTests.c,95 :: 		USART1_CR1.TE = 1 ;               // enable tx
MOVW	R0, #lo_addr(USART1_CR1+0)
MOVT	R0, #hi_addr(USART1_CR1+0)
STR	R2, [R0, #0]
;UartTests.c,97 :: 		NVIC_IntEnable(IVT_INT_USART1);   // Enable UART1 interrupts
MOVW	R0, #53
BL	_NVIC_IntEnable+0
;UartTests.c,98 :: 		USART1_CR1.TXEIE = 0 ;            // disable tx empty interupts     (reset default, can be ignored)
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(USART1_CR1+0)
MOVT	R0, #hi_addr(USART1_CR1+0)
STR	R1, [R0, #0]
;UartTests.c,99 :: 		RXNE_USART1_SR_bit = 0 ;          // clear any pending rx data flag
MOVW	R0, #lo_addr(RXNE_USART1_SR_bit+0)
MOVT	R0, #hi_addr(RXNE_USART1_SR_bit+0)
STR	R1, [R0, #0]
;UartTests.c,100 :: 		RXNEIE_USART1_CR1_bit = 1 ;       // enable rx data ready interupts
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(RXNEIE_USART1_CR1_bit+0)
MOVT	R0, #hi_addr(RXNEIE_USART1_CR1_bit+0)
STR	R1, [R0, #0]
;UartTests.c,102 :: 		while(1) {
L_main9:
;UartTests.c,104 :: 		if(RxCnt > 0) {                  // any rx data ready ?
MOVW	R0, #lo_addr(_RxCnt+0)
MOVT	R0, #hi_addr(_RxCnt+0)
LDRH	R0, [R0, #0]
CMP	R0, #0
IT	LS
BLS	L_main11
;UartTests.c,105 :: 		TxChr(RxData[RxRp]) ;           // yes, send next chr
MOVW	R0, #lo_addr(_RxRp+0)
MOVT	R0, #hi_addr(_RxRp+0)
LDRH	R1, [R0, #0]
MOVW	R0, #lo_addr(_RxData+0)
MOVT	R0, #hi_addr(_RxData+0)
ADDS	R0, R0, R1
LDRB	R0, [R0, #0]
BL	_TxChr+0
;UartTests.c,106 :: 		RxRp++ ;                        // inc rd pntr
MOVW	R1, #lo_addr(_RxRp+0)
MOVT	R1, #hi_addr(_RxRp+0)
LDRH	R0, [R1, #0]
ADDS	R0, R0, #1
UXTH	R0, R0
STRH	R0, [R1, #0]
;UartTests.c,107 :: 		if(RxRp >= RXD_BUFF)            // past end of buffer ?
CMP	R0, #20
IT	CC
BCC	L_main12
;UartTests.c,108 :: 		RxRp = 0 ;                     // yes, wrap to start
MOVS	R1, #0
MOVW	R0, #lo_addr(_RxRp+0)
MOVT	R0, #hi_addr(_RxRp+0)
STRH	R1, [R0, #0]
L_main12:
;UartTests.c,109 :: 		RXNEIE_USART1_CR1_bit = 0 ;     // stop rx data ready interupts
MOVS	R0, #0
SXTB	R0, R0
MOVW	R2, #lo_addr(RXNEIE_USART1_CR1_bit+0)
MOVT	R2, #hi_addr(RXNEIE_USART1_CR1_bit+0)
STR	R0, [R2, #0]
;UartTests.c,110 :: 		RxCnt-- ;                       // dec data cnt
MOVW	R1, #lo_addr(_RxCnt+0)
MOVT	R1, #hi_addr(_RxCnt+0)
LDRH	R0, [R1, #0]
SUBS	R0, R0, #1
STRH	R0, [R1, #0]
;UartTests.c,111 :: 		RXNEIE_USART1_CR1_bit = 1 ;     // restart rx ints
MOVS	R0, #1
SXTB	R0, R0
STR	R0, [R2, #0]
;UartTests.c,112 :: 		}
L_main11:
;UartTests.c,114 :: 		}  // end while
IT	AL
BAL	L_main9
;UartTests.c,116 :: 		} // end main
L_end_main:
L__main_end_loop:
B	L__main_end_loop
; end of _main
_TxChr:
;UartTests.c,119 :: 		unsigned short TxChr(unsigned short chr)
; chr start address is: 0 (R0)
;UartTests.c,122 :: 		if(TxCnt < TXD_BUFF) {           // any space left in buffer ?
; chr end address is: 0 (R0)
; chr start address is: 0 (R0)
MOVW	R1, #lo_addr(_TxCnt+0)
MOVT	R1, #hi_addr(_TxCnt+0)
LDRH	R1, [R1, #0]
CMP	R1, #20
IT	CS
BCS	L_TxChr13
;UartTests.c,123 :: 		TxData[TxWp] = chr ;            // yes, save data
MOVW	R3, #lo_addr(_TxWp+0)
MOVT	R3, #hi_addr(_TxWp+0)
LDRH	R2, [R3, #0]
MOVW	R1, #lo_addr(_TxData+0)
MOVT	R1, #hi_addr(_TxData+0)
ADDS	R1, R1, R2
STRB	R0, [R1, #0]
; chr end address is: 0 (R0)
;UartTests.c,124 :: 		TxWp++ ;                        // inc write pntr
MOV	R1, R3
LDRH	R1, [R1, #0]
ADDS	R1, R1, #1
UXTH	R1, R1
STRH	R1, [R3, #0]
;UartTests.c,125 :: 		if(TxWp >= TXD_BUFF)            // past end of buffer ?
CMP	R1, #20
IT	CC
BCC	L_TxChr14
;UartTests.c,126 :: 		TxWp = 0 ;                     // yes, wrap to start
MOVS	R2, #0
MOVW	R1, #lo_addr(_TxWp+0)
MOVT	R1, #hi_addr(_TxWp+0)
STRH	R2, [R1, #0]
L_TxChr14:
;UartTests.c,127 :: 		TXEIE_USART1_CR1_bit = 0 ;      // stop Tx buffer empty ints
MOVS	R1, #0
SXTB	R1, R1
MOVW	R3, #lo_addr(TXEIE_USART1_CR1_bit+0)
MOVT	R3, #hi_addr(TXEIE_USART1_CR1_bit+0)
STR	R1, [R3, #0]
;UartTests.c,128 :: 		TxCnt++ ;                       // inc data cnt
MOVW	R2, #lo_addr(_TxCnt+0)
MOVT	R2, #hi_addr(_TxCnt+0)
LDRH	R1, [R2, #0]
ADDS	R1, R1, #1
STRH	R1, [R2, #0]
;UartTests.c,129 :: 		TXEIE_USART1_CR1_bit = 1 ;      // yes, re-start ints
MOVS	R1, #1
SXTB	R1, R1
STR	R1, [R3, #0]
;UartTests.c,130 :: 		return(1) ;
MOVS	R0, #1
IT	AL
BAL	L_end_TxChr
;UartTests.c,131 :: 		}
L_TxChr13:
;UartTests.c,134 :: 		return(0) ;                     // no space in buffer - return false
MOVS	R0, #0
;UartTests.c,135 :: 		}
L_end_TxChr:
BX	LR
; end of _TxChr
